
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Qt学习五 - 对话框 / 憋错料</title>

    <meta name="description" content="Qt学习五 - 对话框 一.对话框简介 开发桌面程序,总会需要使用对话框来实现短期任务或者简洁的交互.在Qt中,提供了QDialog类来实现对话框.在QDialog和其子类中,对parent指针有额外的解释:当parent为NULL时,对话框会作为一个顶层窗口,否则则会作为其父组件的子对话框(此时默认显示在父组件的中心位置).可以新建一个项目,在主窗口上添加一个push button,然后在相应的槽函数中添加如下代码: QDialog dlg; dlg.setWindowTitle(&quot;hello dialog ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Qt学习五 - 对话框</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h3>一、对话框简介</h3>
<p>开发桌面程序，总会需要使用对话框来实现短期任务或者简洁的交互。在Qt中，提供了QDialog类来实现对话框。在QDialog和其子类中，对parent指针有额外的解释：当parent为NULL时，对话框会作为一个顶层窗口，否则则会作为其父组件的子对话框（此时默认显示在父组件的中心位置）。可以新建一个项目，在主窗口上添加一个push button，然后在相应的槽函数中添加如下代码：</p>
<pre>    QDialog dlg;
    dlg.setWindowTitle("hello dialog !");
    dlg.exec();</pre>
<p>运行程序查看效果，然后将其修改为：</p>
<pre>    QDialog dlg(this);
    dlg.setWindowTitle("hello dialog !");
    dlg.exec();</pre>
<p>再运行程序，对比两次的差别。</p>
<p>对话框分为模态对话框和非模态对话框两种。模态对话框又分为应用级别的模态对话框和窗口级别的模态对话框。应用级别的模态对话框会阻塞同一应用下的所有窗口，当对话框出现时，用户先要和对话框进行交互，直到对话框关闭才可以和访问其他窗口；窗口级别的模态对话框只会阻塞与对话框相关联的窗口，允许用户与其他窗口进行交互；非模态对话框则与模态对话框相反，它不会阻塞用户与任何窗口的交互。</p>
<p>Qt中，实现应用级别的模态对话框使用QDialog::exec()函数，例如我们上面写的代码，实现窗口级别的模态对话框使用QDialog::open()函数，实现非模态对话框使用QDialog::show()函数。将上面的代码改为非模态对话框方式：</p>
<pre>    QDialog dlg;
    dlg.setWindowTitle("hello dialog !");
    dlg.show();</pre>
<p>运行发现对话框一闪而过，这是因为对话框创建在栈上，并且show()函数不会阻塞当前线程，对话框显示后代码会继续向下执行，当执行完按钮的槽函数后，超出对话框的作用域，对话框就被析构了。所以需要将对话框创建在堆上，如下：</p>
<pre>    QDialog* dlg = new QDialog;
    dlg-&gt;setWindowTitle("hello dialog !");
    dlg-&gt;show();</pre>
<p>创建在堆上就会涉及到释放内存，我们可以指定对话框的parent 为主窗口</p>
<pre> QDialog* dlg = new QDialog(this);</pre>
<p>但是这样如果主窗口不关闭，dialog就不会被销毁，内存会一直被占用。并且QWidget类的parent只能是QWidget的指针，如果对话框不是显示在界面类上怎么办？针对这个问题，我们可以设置QDialog的WindowAttribute</p>
<pre>    QDialog* dlg = new QDialog;
    dlg-&gt;setWindowTitle("hello dialog !");
    dlg-&gt;setAttribute(Qt::WA_DeleteOnClose);
    dlg-&gt;show();</pre>
<p>这样当对话框关闭时会自动销毁，QObject类还有一个deleteLater()函数，该函数会在事件循环结束后销毁该对话框。</p>
<h3>二、对话框数据传递</h3>
<p>从模态对话框获取数据：</p>
<pre>    QDialog dlg;
    dlg.exec();
    qDebug() &lt;&lt; dlg.result();</pre>
<p>运行后，不会获取到结果，这是因为exec()（开启一个事件循环）会阻塞当前线程，当关闭对话框exec()函数返回时才会执行下面的代码，才可以获取到数据。如果设置了WA_DeleteOnClose，那么当对话框关闭时就会被销毁，就不能用这种方法获取数据了。exec()函数有两个返回值：QDialog::Accepted和QDialog::Rejected，通常我们会使用类似下面的代码：</p>
<pre>    QDialog dlg;
    if (dlg.exec() == QDialog::Accepted)
    {
        //do something
    }
    else
    {
        //do something
    }</pre>
<p>从非模态对话框获取数据：</p>
<p>因为QDialog::show()函数不会阻塞线程，show()会立即返回，所以不能通过上面的方式来获取数据，否则不等用户输入，已经执行了下面的代码。我们可以使用信号和槽机制，来获取数据。非模态对话框在关闭时可以调用QDialog::accept()或者QDialog::reject或者QDialog::done()函数，所以我们可以重写QDialog::accept()函数，在这里发送信号。也可以重写QDialog::closeEvent()函数来发送信号。然后在需要接受数据的窗口链接这个信号即可。</p>
<p>在QDialog子类中：</p>
<pre>    void UserAgeDialog::accept()
    {
        emit userAgeChanged(newAge); // newAge is an int
        QDialog::accept();
    }</pre>
<p>在mainwindow中：</p>
<pre>    void MainWindow::showUserAgeDialog()
    {
        UserAgeDialog *dialog = new UserAgeDialog(this);
        connect(dialog, &amp;UserAgeDialog::userAgeChanged, this, &amp;MainWindow::setUserAge);
        dialog-&gt;show();
    }</pre>
<pre>    void MainWindow::setUserAge(int age)
    {
        userAge = age;
    }</pre>

<h3>三、标准对话框</h3>
<p>标准对话框就是Qt内置的对话框，它们都是继承与QDialog类。打开帮助文档找到QDialog类，</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY5ODUzMS8yMDE3MDQvNjk4NTMxLTIwMTcwNDA3MTgzNzQ4MDUwLTk3NTI2NjQwNi5wbmc=.jpg"></p>
<p>可以看到当前版本Qt所支持的内置对话框。</p>
<ul>
<li>QColorDialog：选择颜色</li>
<li>QErrorMessage：错误提示</li>
<li>QFileDialog：选择文件</li>
<li>QFontDialog：选择字体</li>
<li>QinputDialog：允许用户输入一个值，并返回该值</li>
<li>QMessageBox：模态对话框，用于提示信息，询问问题等</li>
<li>QProgressDialog：显示操作过程</li>
</ul>
<p>下面以QMessageBox为例，做个简单介绍，QMessageBox用于显示信息提示，我们通常会用到以下几个静态函数：</p>
<ul>
<li><code>void about(QWidget * parent, const QString &amp; title, const QString &amp; text)</code>：显示关于对话框。这是一个最简单的对话框，其标题是 title，内容是 text，父窗口是 parent。对话框只有一个 OK 按钮。</li>
<li><code>void aboutQt(QWidget * parent, const QString &amp; title = QString())</code>：显示关于 Qt 对话框。该对话框用于显示有关 Qt 的信息。</li>
<li><code>StandardButton critical(QWidget * parent, const QString &amp; title, const QString &amp; text, StandardButtons buttons = Ok, StandardButton defaultButton = NoButton)</code>：显示严重错误对话框。这个对话框将显示一个红色的错误符号。我们可以通过 buttons 参数指明其显示的按钮。默认情况下只有一个 Ok 按钮，我们可以使用<code>StandardButtons</code>类型指定多种按钮。</li>
<li><code>StandardButton information(QWidget * parent, const QString &amp; title, const QString &amp; text, StandardButtons buttons = Ok, StandardButton defaultButton = NoButton)</code>：<code>QMessageBox::information()</code>函数与<code>QMessageBox::critical()</code>类似，不同之处在于这个对话框提供一个普通信息图标。</li>
<li><code>StandardButton question(QWidget * parent, const QString &amp; title, const QString &amp; text, StandardButtons buttons = StandardButtons( Yes | No ), StandardButton defaultButton = NoButton)</code>：<code>QMessageBox::question()</code>函数与<code>QMessageBox::critical()</code>类似，不同之处在于这个对话框提供一个问号图标，并且其显示的按钮是“是”和“否”两个。</li>
<li><code>StandardButton warning(QWidget * parent, const QString &amp; title, const QString &amp; text, StandardButtons buttons = Ok, StandardButton defaultButton = NoButton)</code>：<code>QMessageBox::warning()</code>函数与<code>QMessageBox::critical()</code>类似，不同之处在于这个对话框提供一个黄色叹号图标。</li>
</ul>
<p>我们通过以下示例来了解一下QMessageBox的简单使用：</p>
<pre>    if (QMessageBox::Yes == QMessageBox::question(this,"question","are you ok?",QMessageBox::Yes|QMessageBox::No,QMessageBox::Yes))
    {
        QMessageBox::information(this,"information","I‘m glad to hear that");
    }
    else {
        QMessageBox::information(this,"information","i‘m sorry");
    }</pre>
<p>我们首先使用question来询问一个问题，然后根据用户点击的按钮不同作出相应的反应。QMessageBox类的static函数使用起来非常简单方便，如果我们需要进行定制QMessageBox，则可以通过设置其属性来实现。例如做一个询问是否需要保存的对话框：</p>
<pre>    //首先创建一个QMessagBox
    QMessageBox box;
    //设置对话框标题
    box.setText("The document has been modified");
    //设置对话框信息
    box.setInformativeText("Do you want to save your changes?");
    //设置详细信息，设置此属性，对话框会有一个show details的按钮，当点击该按钮时，显示详细信息
    box.setDetailedText("this is detail information");
    //设置对话框按钮
    box.setStandardButtons(QMessageBox::Save|QMessageBox::Discard|QMessageBox::Cancel);
    //设置对话框默认按钮
    box.setDefaultButton(QMessageBox::Save);
    //显示对话框并接受返回值
    int ret = box.exec();
    //根据返回值不同，作出相应的操作
    switch (ret) {
    case QMessageBox::Save:
        qDebug() &lt;&lt; "save";
        break;
    case QMessageBox::Discard:
        qDebug() &lt;&lt; "discard";
        break;
    case QMessageBox::Cancel:
        qDebug() &lt;&lt; "cancel";
        break;
    default:
        break;
    }</pre>
<p>运行结果如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY5ODUzMS8yMDE3MDQvNjk4NTMxLTIwMTcwNDA5MjAyNzU4NjYwLTE0Njc1NDMxMjIucG5n.jpg"></p>
<p>我这是在Mac下，如果是在windows下，那么Qt会自动将其设置为适应windows习惯的对话框。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-07 17:04:05 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/text/" title="text">text</a>, <a href="https://www.biecuoliao.com/tag/ons/" title="ons">ons</a>, <a href="https://www.biecuoliao.com/tag/event/" title="event">event</a>, <a href="https://www.biecuoliao.com/tag/%e5%88%9b%e5%bb%ba/" title="创建">创建</a>, <a href="https://www.biecuoliao.com/tag/result/" title="result">result</a>, <a href="https://www.biecuoliao.com/tag/ssd/" title="ssd">ssd</a>, <a href="https://www.biecuoliao.com/tag/modified/" title="modified">modified</a>, <a href="https://www.biecuoliao.com/tag/%e5%87%bd%e6%95%b0%e8%bf%94%e5%9b%9e/" title="函数返回">函数返回</a>, <a href="https://www.biecuoliao.com/tag/eject/" title="eject">eject</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Qt学习五 - 对话框的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLAXeA0.html" rel="bookmark">qt学习 &lpar;五&rpar; 登陆界面之连接按钮</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				登陆步骤是比对输入的账号密码与数据库中的表项目是否一致 一样,  跳出mainwidget对话框 不一样,跳出消息错误框 今天就是要进去, 因为进去以后是widget的窗口,所以把用来核对消息的数据库放在MAINwidget.cpp中, 再拿一个用户点击连接的子类 login.cpp, 就在这里面画用户登录账号密码textEdit 1 除了textEdit 基本都是button 慢慢加. 登录界面可以学的东西很多. 2 在widget.h文件中加入数据库所需要的头文件, #include &lt;Qt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/9MElo14.html" rel="bookmark">QT学习 之 对话框 （四） 字体对话框、消息对话框、文件对话框、进程对话框（超详细中文注释）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				QMessageBox类: 含有Question消息框.Information消息框.Warning消息框和Critical消息框等 通常有两种方式可以来创建标准消息对话框: 一种是采用“基于属性”的API,一种是使用QMessageBox的静态方法. 后者书写容易,但缺少灵活性,针对用户给出的提示的信息不够丰富,并且不能自定义消息对话框里面的按钮提示信息.因此推荐第一种写法. [cpp] view plaincopy &lt;span style=&quot;font-size:18px;&quot;&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49r8lnM.html" rel="bookmark">QT学习之路--创建一个对话框</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Q_OBJECT:这是一个宏,凡是定义信号槽的类都必须声明这个宏. 函数tr()全名是QObject::tr(),被他处理过的字符串可以使用工具提取出来翻译成其他语言,也就是做国际化使用. 对于QT学习之路:Qt学习之路(7):创建一个对话框(上)这个程序.编译出现 invalid use of incomplete type ‘class QPushButton’ findButton-&gt;setEnabled(!text.isEmpty()); ^ In file included from			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDqeyY0.html" rel="bookmark">【qt学习004】对话框小结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一部分,基本对话框告一段落. 书本上第一章节还介绍了制作抽屉效果.制作表格.制作进度条等节,但在我看来,似乎与前面的对话框制作方式大同小异,不值得费时费力地一一学习,所以跳过了,这一跳,就到了书本的50多页,七分之一的比例,进度神速啊,这样想想感觉倍儿爽,但或许我会后悔. 回顾整个第一章,有几个步骤属于通用的: 1. 继承public QDialog类. 2. 创建对象,有QLabel, QPushButton等. 3. 布局,暂时用到了QGridLayout类以及其方法addWidget,简			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xWQPLM.html" rel="bookmark">qt学习笔记（五） QGraphicsPixmapItem与QGraphicsScene的编程实例 图标拖动渐变效果</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				应大家的要求,还是把完整的project文件贴出来,大家省点事:http://www.kuaipan.cn/file/id_48923272389086450.htm 先看看执行效果,我用的群创7寸屏,主机是mini2440,分辨率是800*480,程序写比較粗糙,但对刚開始学习的人还是有一点启示,大家一起进步. qt中提供了QGphicsView,QGraphicsScene,QGraphicsItem,QGraphicsPixmapItem是QGraphicsItem的子类 分辨创建它们的实			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47meoD0.html" rel="bookmark">qt学习（四）主窗选钮，显示新窗口。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				游戏有选区这个习惯, 当然,我特指&lt;冒险岛&gt;了,有的时候就是打开一个主屏幕上五个按钮让你点击进入, 甚至有的时候进去了还要选哪个频道,游戏服务器都得分区,频道来完成功能.现在我们先进入想选的区,不需要的可以看以后的登陆窗口了. 这一次的主要功能是完成选区,选完进入输入账号界面. 这次用的是一个点完出啦一个所以需要两个窗口,在原有的基础上新建qt设计师界面类.选择dialogwithoutbutton. 把最后一个要显示的当作主界面, 其他的都可以选择dialog模板, 完成以后,画ui界面,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OQKk9M.html" rel="bookmark">Qt学习&lpar;7&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Qt学习(7)——Hello Designer 上一节的 Hello Widget 例子中,主界面窗口的尺寸和标签控件显示的矩形区域等,都是用 C++ 代码编写的.窗口和控件的尺寸都是预估的,控件如果多起来,那就不好估计每个控件合适的位置和大小了. 用 C++ 代码编写图形界面的问题就是不直观,因此 Qt 项目开发了专门的可视化图形界面编辑器—— Qt Designer, 即 Qt 设计师.通过设计师就可以很方便地创建图形界面文件 *.ui ,然后将 ui 文件应用到源代码里面,做到所见即所得(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41BwrOM.html" rel="bookmark">QT学习笔记&mdash;1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.模态和非模态的区别:非模态可以同时操作两个窗口,模态的只能在顶层窗口关闭之后才能使用其他窗口 //同时显示出widget和dialog窗口,非模态     QDialog *dialog = new QDialog(this);     dialog-&gt;show(); //同时显示出widget和dialog窗口,模态     QDialog *dialog = new QDialog(this);     dialog-&gt;setModal(true);     dialog-&gt;sh			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ORKVK0.html" rel="bookmark">【qt学习】开篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				重新开始学习qt,在年前已经看过一些知识点,但毫无进展,始终停留在知识点的阶段,或许有qt考试的话,我可以考得不错.然而学习qt,更多的是为了实战应用,并将其变成自己的兵器. 开始学习之前,先说说早前的一个困惑--为什么学习qt?最初学习qt,是因为身边朋友的强烈推荐,他说通过学习图形界面编程可以提高c++编程能力,而图形界面编程无非两种,一种MFC,另一种就qt了,MFC极其变态,想要简单快速,就学qt吧,于是我就开始看qt了.没过多久我有些动摇了,随着互联网时代的来临,编程方式正在慢慢改变,			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Z0K6LwM.html" rel="bookmark" class="title">百度the big talk节目</a>
					<div>
						主要事件 2015-03-09期:硅谷峰会:智能机器人&amp;对话沃兹尼亚克 2015-03-02期:硅谷峰会:创新金融和智能城市 2015-02-15期:硅谷峰会:数字生物学和数字医药 2015- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVgGAy0.html" rel="bookmark" class="title">基于jquery的has&lpar;&rpar;方法以及与find&lpar;&rpar;方法以及filter&lpar;&rpar;方法的区别详解</a>
					<div>
						1. has(selector选择器或DOM元素)   将匹配元素集合根据选择器或DOM元素为条件,检索该条件在每个元素的后代中是否存在,将符合条件的的元素构成新的结果集. 例子如下:&lt;ul&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0by2lkM.html" rel="bookmark" class="title">django框架&amp;lt&semi;三&amp;gt&semi;</a>
					<div>
						一.ORM操作  1.django orm创建数据库的方法 (1)指定连接pymysql(python3.x),先配置__init__.py import pymysql pymysql.instal ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXol73.html" rel="bookmark" class="title">巧用tar命令</a>
					<div>
						tar命令可以对文件进行归档.它最初设计是用来将数据存储在磁带上.tar可以将多个文件和文件夹保存为单个文件,同时还能保留所有的文件属性,如所有者.权限等.由tar创建的文件通常称为Tarball.下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41gR8k0.html" rel="bookmark" class="title">MySQL多表关联查询与存储过程</a>
					<div>
						1.多表关联查询 --  **************关联查询(多表查询)**************** -- 需求:查询员工及其所在部门(显示员工姓名,部门名称) -- 1.1 交叉连接查询(不推 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49bxkpM.html" rel="bookmark" class="title">style：定宽浮动</a>
					<div>
						.PopPage { position: relative; /*相对定位*/ width: 98%; margin: auto; padding-top: 4px; } .PopPage div { ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qoJl9M.html" rel="bookmark" class="title">版本管理软件和项目管理软件</a>
					<div>
						1.Team Foundation Server(TFS)是这样一种服务器产品,它需要部署到软件开发环境中,这样开发人员就可以使用它提供的各种服务.因为TFS是设计用于大规模团队,因而有两种拓扑结构供 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O7ygo3.html" rel="bookmark" class="title">php中str&lowbar;replace和str&lowbar;ireplace的用法和区别</a>
					<div>
						str_replace() 函数 定义:使用一个字符串替换字符串中的另一些字符,对大小写敏感的搜索 语法: str_replace(find,replace,string,count) str_ire ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O79y93.html" rel="bookmark" class="title">被一个大学录了，能申请退档参加征集志愿吗</a>
					<div>
						急求解大学生活马上到了 我该在大学里怎么生活呢 求过来人的帮助 新生提前一天报道,和正常报道有区别吗?提前一天,是不是也能把该领的东西都能领,然后该办的手续都能办了?关键问题是能见到导员么?还是只是让 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLW67A4.html" rel="bookmark" class="title">hdu 4035 概率dp</a>
					<div>
						太吊了 1 /* 2 HDU 4035 3 4 dp求期望的题. 5 题意: 6 有n个房间,由n-1条隧道连通起来,实际上就形成了一棵树, 7 从结点1出发,开始走,在每个结点i都有3种可能: 8  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JY9nV3.html" rel="bookmark" class="title">修改extjs源码关闭按钮样式</a>
					<div>
						首先通过文件引用找到extjs的样式文件: &lt;link rel=&quot;stylesheet&quot; type=&quot;text/css&quot; href=&quot;&lt;% ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M651zv4.html" rel="bookmark" class="title">robotframework笔记19</a>
					<div>
						后处理输出 使用时自动测试 在测试执行报告和日志生成,并使用它 分别允许创建自定义报告和日志以及结合 和合并的结果. 使用Rebot 简介 rebot [options] robot_outputs  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPwGgB4.html" rel="bookmark" class="title">hdu 2021 发工资咯：）</a>
					<div>
						题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2021 题目大意:给老师发工资,找出最少的人民币张数. 1 #include &lt;stdio.h&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWVZBm4.html" rel="bookmark" class="title">bzoj 1037 &lbrack;ZJOI2008&rsqb;生日聚会Party（DP）</a>
					<div>
						[题目链接] http://www.lydsy.com/JudgeOnline/problem.php?id=1037 [题意] 一排n男m女,求满足任意连续段男女人数之差不超过k的数目. [思路]  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGddZG0.html" rel="bookmark" class="title">第四周项目-1&period;2</a>
					<div>
						#include&lt;iostream&gt; #include&lt;cmath&gt; using namespace std; class Triangle { public: double  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGADmA3.html" rel="bookmark" class="title">Guava Futures异步回调机制源码解析</a>
					<div>
						本文是在学习中的总结,欢迎转载但请注明出处:http://blog.csdn.net/pistolove/article/details/51758194 1.前言 在前两篇文章中简单阐述了Java  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AWyog0.html" rel="bookmark" class="title">Ubuntu下，terminal常用快捷键</a>
					<div>
						# ctrl + l - 清屏 . cLear # ctrl + c - 终止命令. # ctrl + d - 退出 shell,好像也可以表示EOF. # ctrl + r - 从命令历史中找 .  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzkDbl0.html" rel="bookmark" class="title">&lpar;error&rpar; DENIED Redis is running in protected mode because protected mode is enabled</a>
					<div>
						在通过Java程序链接配置好的redis服务时出现 DENIED Redis is running in protected mode because protected mode is enable ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBzxJjM.html" rel="bookmark" class="title">字符串的案例，代码详解</a>
					<div>
						 A:模拟用户登录 /* * 模拟登录,给三次机会,并提示还有几次. *  * 分析: *         A:定义用户名和密码.已存在的. *         B:键盘录入用户名和密码. *     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02rBjD0.html" rel="bookmark" class="title">指针版邻接表</a>
					<div>
						比起数组优点有三: 1.代码量少 2.fch再也不用想着清-1,不用纠结反向弧 3.更好理解了 1 #include&lt;iostream&gt; 2 #include&lt;cstdio&gt;  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
